from leapp.actors import Actor
from leapp.models import InstalledRedHatSignedRPM, RpmTransactionTasks
from leapp.libraries.stdlib import api
from leapp.tags import FactsPhaseTag, IPUWorkflowTag

class CheckBCCRpm(Actor):
    """
    The actor will remove the bcc rpm.
    """
    name = 'bcc_rpm_checks'
    consumes = (InstalledRedHatSignedRPM, )
    produces = (RpmTransactionTasks, )
    tags = (FactsPhaseTag, IPUWorkflowTag)

    def process(self):
        # Convert installed packages message to list
        packages_list = next(api.consume(InstalledRedHatSignedRPM), InstalledRedHatSignedRPM()).items

        to_remove_pkgs = []
        bcc_rpms = ['bcc', 'bcc-tools', 'python-bcc']
        for pkg in packages_list:
            if pkg.name in bcc_rpms:
                to_remove_pkgs.append(pkg.name)

        if to_remove_pkgs:
            self.produce(RpmTransactionTasks(to_remove=to_remove_pkgs))
            api.current_logger().info("Attention: BCC rpms will be removed: " + '|'.join(to_remove_pkgs))
