from leapp.actors import Actor
from leapp.libraries.actor import eval_ovl_size
from leapp.models import Report
from leapp.tags import FactsPhaseTag, IPUWorkflowTag

class CheckDiskAvail(Actor):
    """
    The actor will check whether the free space on the disk is not enough.
    """
    name = 'disk_avail_checks'
    consumes = ()
    produces = (Report,)
    tags = (FactsPhaseTag, IPUWorkflowTag)

    def process(self):
        eval_ovl_size.process()
