import subprocess
from leapp.actors import Actor
from leapp.models import InstalledRedHatSignedRPM
from leapp.libraries.stdlib import api
from leapp.tags import InterimPreparationPhaseTag, IPUWorkflowTag

class RedhatReleaseWorkaround(Actor):
    """
    workaround for updating from Redhat to BCLinux.
    """
    name = 'redhat_release_workaround'
    consumes = (InstalledRedHatSignedRPM, )
    produces = ()
    tags = (InterimPreparationPhaseTag, IPUWorkflowTag)

    def process(self):
        # Convert installed packages message to list
        packages_list = next(api.consume(InstalledRedHatSignedRPM), InstalledRedHatSignedRPM()).items

        rh_release_eula_pkg = 'redhat-release-eula'

        for pkg in packages_list:
            if pkg.name == rh_release_eula_pkg:
                rh_release_eula_pkg_fullname = rh_release_eula_pkg + "-{0}-{1}".format(pkg.version, pkg.release)
                ret = subprocess.call("rpm -e --nodeps {}".format(rh_release_eula_pkg_fullname), shell=True)
                if ret == 0:
                    api.current_logger().info("Attention: {} been removed success.".format(rh_release_eula_pkg_fullname))
                else:
                    api.current_logger().info("Attention: Failed to remove {}.".format(rh_release_eula_pkg_fullname))

                break

        subprocess.call("rm -fr /usr/share/redhat-release/ /usr/share/doc/redhat-release/", shell=True)
